import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import React, { useCallback, useState } from 'react';
import purebem from 'purebem';
import FoundationTableRowSearchResultGroup from '../search-result-group/FoundationTableRowSearchResultGroup';
import FoundationTableRowGroupContext from './FoundationTableRowGroupContext';
import './FoundationTableRowGroup.scss';
export default function FoundationTableRowGroup(_ref) {
  var _ref$additionalData = _ref.additionalData,
      additionalData = _ref$additionalData === void 0 ? {} : _ref$additionalData,
      columns = _ref.columns,
      isFetching = _ref.isFetching,
      isLast = _ref.isLast,
      isOdd = _ref.isOdd,
      isSearchResult = _ref.isSearchResult,
      item = _ref.item,
      _ref$searchFields = _ref.searchFields,
      searchFields = _ref$searchFields === void 0 ? [] : _ref$searchFields,
      searchQuery = _ref.searchQuery,
      TableRow = _ref.TableRow,
      TableRowExpandResultGroup = _ref.TableRowExpandResultGroup;
  var block = purebem('foundation-table-row-group');

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      isExpanded = _useState2[0],
      setExpanded = _useState2[1];

  var _useState3 = useState(false),
      _useState4 = _slicedToArray(_useState3, 2),
      isHighlighted = _useState4[0],
      setHighlighted = _useState4[1];

  var collapse = useCallback(function collapse() {
    setExpanded(false);
  }, []);
  var expand = useCallback(function expand() {
    setExpanded(true);
  }, []);
  var highlight = useCallback(function highlight() {
    setHighlighted(true);
  }, []);
  var unhighlight = useCallback(function unhighlight() {
    setHighlighted(false);
  }, []);
  var toggleExpanded = useCallback(function toggleExpanded() {
    setExpanded(!isExpanded);
  }, [isExpanded]);
  var toggleHighlighted = useCallback(function toggleHighlighted() {
    setHighlighted(!isHighlighted);
  }, [isHighlighted]);
  var context = {
    collapse: collapse,
    columns: columns,
    expand: expand,
    isExpanded: isExpanded,
    isHighlighted: isHighlighted,
    highlight: highlight,
    unhighlight: unhighlight,
    toggleExpanded: toggleExpanded,
    toggleHighlighted: toggleHighlighted
  };
  var _even$expanded$fetchi = {
    even: !isOdd && !isSearchResult,
    expanded: isExpanded,
    fetching: isFetching,
    highlighted: isHighlighted,
    last: isLast && !isSearchResult,
    odd: isOdd && !isSearchResult,
    search: isSearchResult
  },
      even = _even$expanded$fetchi.even,
      expanded = _even$expanded$fetchi.expanded,
      fetching = _even$expanded$fetchi.fetching,
      highlighted = _even$expanded$fetchi.highlighted,
      last = _even$expanded$fetchi.last,
      odd = _even$expanded$fetchi.odd,
      search = _even$expanded$fetchi.search;
  return React.createElement(FoundationTableRowGroupContext.Provider, {
    value: context
  }, React.createElement("tbody", {
    className: block({
      even: even,
      expanded: expanded,
      fetching: fetching,
      highlighted: highlighted,
      last: last,
      odd: odd,
      search: search
    })
  }, React.createElement(TableRow, {
    additionalData: additionalData,
    data: item.data
  }), isExpanded && TableRowExpandResultGroup !== void 0 ? React.createElement(TableRowExpandResultGroup, {
    additionalData: additionalData,
    data: item.data
  }) : null, isSearchResult ? React.createElement(FoundationTableRowSearchResultGroup, {
    data: item.data,
    fields: searchFields,
    query: searchQuery
  }) : null));
}
//# sourceMappingURL=FoundationTableRowGroup.js.map